#! /usr/bin/env node

const Git = require('nodegit');
const shell = require('shelljs');
const logSymbols = require('log-symbols');
const path = require('path');
const fs = require('fs');

const current = process.cwd();
const destination = process.argv.length > 2 ? path.join(current, process.argv[2]) : current;

const destinationExists = fs.existsSync(destination);
if (destinationExists) {
    console.warn(logSymbols.error, `Folder "${destination}" already exists. Aborting...`)
    process.exit(1);
}

console.log(logSymbols.info, 'Acquiring payload...');
Git.Clone("https://github.com/MustansirZia/next-express-bootstrap-boilerplate", destination).then(function(repository) {
    console.log(logSymbols.success, 'Payload acquired!\n');
    shell.rm('-rf', path.join(destination, '.git'));
    shell.rm('-f', path.join(destination, 'README.md'));
    shell.rm('-f', path.join(destination, 'logo.png'));
    console.log(logSymbols.info, 'Attaching boosters...\n');
    shell.cd(destination)
    shell.exec(`${isYarnAvailable() ? 'yarn' : 'npm i'}`)
    console.log('\n', logSymbols.success, 'Boosters attached!\n');
    console.log(logSymbols.success, 'Success! Your awesome next-express-bootstrap-boilerplate launched!\n');
    process.exit(0);
});

const isYarnAvailable = () => shell.exec('yarnpkg --version').code === 0;
